﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using Silanis.ESL.SDK;
using Newtonsoft.Json.Linq;
using System.Net.Http;
using System.Net.Http.Headers;
using System.Diagnostics;

namespace esl
{
    class BulkSignForSigner
    {
        public static void main()
        {
            //Build http client
            HttpClient myClient = new HttpClient();
            myClient.DefaultRequestHeaders.Add("Authorization", "Basic " + Properties.Settings.Default.key);
            myClient.DefaultRequestHeaders.Add("Accept", "application/json");

            string packageId = "8cgDMxd33PQqga2oOaAfaUGX-fc=";

            //First call is to create a signer authentication token
            string jsonString = "{\"packageId\":\""+ packageId +"\",\"signerId\":\"signer1\",\"sessionFields\":{\"Bulk Signing on behalf of\":\"signer1\"},\"value\":null}";
            StringContent jsonContent = new StringContent(jsonString, Encoding.UTF8, "application/json");

            var response = myClient.PostAsync(new Uri("https://sandbox.esignlive.com/api/signerAuthenticationTokens"), jsonContent).Result;
            JObject responseJson = JObject.Parse(response.Content.ReadAsStringAsync().Result);
            var signerToken = responseJson["value"];

            //Second call is to create a session token to be used in the Cookie header for the final call
            response = myClient.GetAsync(new Uri("https://sandbox.esignlive.com/auth?signerAuthenticationToken=" + signerToken)).Result;
            responseJson = JObject.Parse(response.Content.ReadAsStringAsync().Result);
            var sessionToken = responseJson["sessionToken"];

            //Third call is to retrieve the documents object
            response = myClient.GetAsync(new Uri("https://sandbox.esignlive.com/api/packages/" + packageId)).Result;
            responseJson = JObject.Parse(response.Content.ReadAsStringAsync().Result);
            var documents = responseJson["documents"];
            JObject doc = new JObject();
            doc.Add("documents", documents);

            //Fourth call is to bulk sign
            //Make sure to replace the authorization header with the cookie header
            myClient.DefaultRequestHeaders.Remove("Authorization");
            myClient.DefaultRequestHeaders.Add("Cookie", "ESIGNLIVE_SESSION_ID=" + sessionToken);

            StringContent jsonContent2 = new StringContent(doc.ToString(), Encoding.UTF8, "application/json");

            response = myClient.PostAsync(new Uri("https://sandbox.esignlive.com/api/packages/" + packageId + "/documents/signed_documents"), jsonContent2).Result;
            Debug.WriteLine(response.Content.ReadAsStringAsync().Result);
        }
    }
}
